<?php

/*

PunBB PHP Localizer (v1.0)
-------------------

This script can be used to create/edit/update PunBB translations.

Place this script in the "lang" folder of your PunBB installation.

                      * * * * NOTE * * * *

    PHP MUST HAVE READ/WRITE PERMISSION TO THE LANG FOLDERS!

  BEFORE TRANSLATING, PLEASE TEST THE SAVE FUNCTION, TO ENSURE
                THAT YOU DON'T LOOSE YOUR WORK!

                      * * * * NOTE * * * *

To create a new translation, copy the 'en' folder to a new folder,
and name it appropritately.

To edit an existing translation, set $translate_from to 'en', and
$translate_to to the name of the translation you wish to edit.

To update a translation for a newer version of PunBB, do the same,
and use the latest version of the 'en' PunBB language files with
your outdated translation.

Change the from and to settings below - the language you translate
from, will be used as the template for the new files; any code and
comments will be copied from the template, while only translated
strings will be copied from the translation - deprecated strings
will be dropped, comments and additional code will be dropped from
the translation as well, so if you have special language handling
built into _common.php (for example, charset handling for chinese),
make sure you back up the original files first, and then copy the
code back in when you're done!

Save as often as you like - missing strings and strings that have
not yet been translated, will be highlighted in red.

*/

$translate_from = 'en';
$translate_to = 'ch_simp';

require('_localizer.php');

error_reporting(E_ERROR | E_WARNING | E_PARSE);

$action = $_POST["action"];

if ($action == 'save')
	header("Location: localizer.php"); 

?>
<HTML>

<HEAD>

<TITLE>PunBB PHP Localizer</TITLE>

<STYLE>
	BODY, TD, TH {
		font-family: verdana,arial,helvetica;
		font-size: 11px;
	}
	.pt_title {
		width: 100%;
		border: 1px solid #000000;
		padding: 2px;
		padding-left: 4px;
		margin-bottom: 4px;
		margin-top: 4px;
		font-weight: bold;
		background-color: #D0D0FF;
	}
	.pt_table {
		border: 0px;
		width: 100%;
		border-collapse: collapse;
	}
	.pt_table TD {
		padding: 4px;
		vertical-align: top;
		border: 1px solid #000000;
	}
	.pt_table TH {
		padding: 4px;
		border: 2px solid #000000;
		background-color: #D0D0D0;
	}
	.pt_input {
		width: 100%;
		font-size: 18px; /* change the font size of the editing boxes here, if you like */
		background-color: transparent;
		border: 0px;
	}
</STYLE>

<?php

$output = array();

$merge = false;
$localized = load_language($translate_to);

$merge = false;
$template = load_language($translate_from);

$charset = $localized['_common.php']['$lang_common']['lang_encoding'];

echo '<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset='.$charset.'">';

?>

</HEAD>

<BODY>

<H1><CENTER>PunBB PHP Localizer</CENTER></H1>

<FORM ACTION="localizer.php" METHOD=POST>
<INPUT TYPE=HIDDEN NAME="action" VALUE="save">

<?php

$count = 0;

function hidden($val) {
	global $count;
	$count++;
	echo '<INPUT TYPE=HIDDEN NAME="v'.$count.'" VALUE="'.$val.'">';
}

if ($action == 'save') {
	// Parse submitted form:
	$localized = array();
	$count = $_POST["count"];
	for ($i=1; $i<=$count; $i++) {
		switch (substr($_POST["v".$i], 0, 2)) {
			case 'f:':
				$file = substr($_POST["v".$i], 2);
				break;
			case 'a:':
				$arr_name = substr($_POST["v".$i], 2);
				break;
			default:
				$localized[$file][$arr_name][$_POST["v".$i]] = $_POST["t".$i];
		}
	}
	// Merge with template:
	$merge = true;
	$template = load_language($translate_from);
	// Save output files:
	foreach ($output as $file => $contents)
		file_put_contents_php4($translate_to.'/'.$translate_to.$file, $contents);
} else {
	// Build the form:
	foreach ($template as $file => $array) {
		hidden('f:'.$file);
		foreach ($template[$file] as $array => $data) {
			hidden('a:'.$array);
			echo '<SPAN CLASS="pt_title">*'.$file.' : '.$array.'</SPAN>';
			echo '<TABLE CLASS="pt_table"><TR><TH WIDTH=20%>Key</TH><TH WIDTH=40%>Template</TH><TH WIDTH=40%>Localized</TH></TR>';
			$alt = true;
			foreach ($template[$file][$array] as $name => $value) {
				$alt = !$alt;
				$color = ($alt ? '#F0F0F0' : null);
				if (!$localized[$file][$array][$name] || ($localized[$file][$array][$name] == $template[$file][$array][$name]))
					$color = '#FFD0D0';
				hidden($name);
				echo '<TR'.($color ? ' BGCOLOR='.$color : '').'><TD>'.$name.'</TD><TD>'.$template[$file][$array][$name].'</TD><TD>'.'<TEXTAREA DIR='.$localized['_common.php']['$lang_common']['lang_direction'].' ROWS=4 NAME="t'.$count.'" CLASS="pt_input">'.$localized[$file][$array][$name].'</TEXTAREA></TD></TR>'."\n";
			}
			foreach ($localized[$file][$array] as $name => $value) {
				if (!$template[$file][$array][$name]) {
					$alt = !$alt;
					$color = ($alt ? '#F0F0F0' : null);
					echo '<TR'.($color ? ' BGCOLOR='.$color : '').' STYLE="color:#808080"><TD>'.$name.'</TD><TD><B>DEPRECATED</B></TD><TD>'.'<DIV CLASS="pt_input">'.$localized[$file][$array][$name].'</DIV></TD></TR>'."\n";
				}
			}
			echo '</TABLE>';
			echo '<INPUT TYPE=HIDDEN NAME="count" VALUE="'.$count.'">';
		}
	}
}

?>

<BR>
<SPAN CLASS="pt_title">
	<CENTER>
		<BR>WARNING:<BR>
		Saving will OVERWRITE existing files! BACK UP FIRST!
		<BR><BR>
		<INPUT TYPE=SUBMIT VALUE="&gt;&gt; WHEN YOU'RE DONE, CLICK HERE TO SAVE &lt;&lt;">
	</CENTER>
	<BR>
</SPAN>

</FORM>

</BODY>

</HTML>
